﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using HeuristicLab.Common;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Hive.Contracts.BusinessObjects {
  [StorableClass]
  [Serializable]
  [DataContract]
  public class HivePluginFile : IDeepCloneable {
    [Storable]
    [DataMember]
    public byte[] BinaryFile { get; set; }
    [Storable]
    [DataMember]
    public String Name { get; set; }  

    public HivePluginFile(byte[] binaryFile, String name) {
      BinaryFile = binaryFile;
      Name = name;
    }

    public virtual IDeepCloneable Clone(Cloner cloner) {
      HivePluginFile clone = (HivePluginFile)Activator.CreateInstance(this.GetType(), true);
      cloner.RegisterClonedObject(this, clone);
      clone.Name = this.Name;
      if (this.BinaryFile != null) {
        clone.BinaryFile = new byte[this.BinaryFile.Length];
        Array.Copy(this.BinaryFile, clone.BinaryFile, this.BinaryFile.Length);
      }
      return clone;
    }

    public object Clone() {
      return Clone(new Cloner());
    }
  }
}
