﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Common;
using HeuristicLab.Collections;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Hive.Contracts.BusinessObjects {
  public class JobResultList : ObservableList<JobResult>, IDeepCloneable {
    public JobResultList() { }
    public JobResultList(IEnumerable<JobResult> collection) {
      this.list = new List<JobResult>(collection);
    }

    [StorableConstructor]
    protected JobResultList(bool deserializing) : base(deserializing) { }

    public object Clone() {
      return Clone(new Cloner());
    }

    public virtual IDeepCloneable Clone(Cloner cloner) {
      JobResultList clone = (JobResultList)Activator.CreateInstance(this.GetType());
      cloner.RegisterClonedObject(this, clone);
      clone.list = (this.Select(x => (JobResult)cloner.Clone(x))).ToList();
      return clone;
    }
  }
}
