﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Principal;
using System.ServiceModel;
using System.Threading;
using System.Security;
using HeuristicLab.Hive.Server.DataAccess;
using HeuristicLab.Hive.Server.Core.InternalInterfaces;
using System.Web.Security;

namespace HeuristicLab.Hive.Server.Core.Authorization {
  public class AuthorizationManager : IAuthorizationManager {
    private MembershipUser Identity {
      get { return Membership.GetUser(); }
    }

    public Guid UserId {
      get { return (Guid)Identity.ProviderUserKey; }
    }

    public void AuthorizeForJobs(params Guid[] jobIds) {
      if (!IsAuthorizedForJobs(jobIds)) {
        throw new SecurityException("User '" + Identity.UserName + "' is not authorized to access job (Id: " + string.Join(", ", jobIds.Select(x => x.ToString()).ToArray()) + ")");
      }
    }
    
    private bool IsAuthorizedForJobs(params Guid[] jobIds) {
      return DaoLocator.JobDao.IsUserAuthorizedForJobs(UserId, jobIds);
    }
  }
}
