﻿using System;
using System.Collections.Generic;
namespace HeuristicLab.Hive.Server.Core.InternalInterfaces {
  public interface IAuthorizationManager {

    Guid UserId { get; }

    /// <summary>
    /// Checks if the user is allowed to access all the jobs.
    /// throws an exception if one of those jobs is inaccessible
    /// </summary>
    /// <exception cref="SecurityException">thrown when access denied</exception>
    void AuthorizeForJobs(params Guid[] jobId);
  }
}
